% Copyright (c) 2010 Iris Yan

% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.

% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


clear all
R=150;
sigma0=4.3;
sigma0_Min=4.3;
N=20;
sample_interval=0.05;
sample_delay=sample_interval*0;
sigma=getsigma(sigma0,N);
sigma_Min=getsigma(sigma0_Min,N);
beta =3.5;
Et=500;
tau_i=2;
tau_o=2;
beta=3.5;
d_pos=120;
d_neg=140;
phai=sqrt(d_pos*d_neg);
hy=10*beta*log10(phai/d_pos);
for i=1:3
    r_HY(i)=120+10*(i-1);
end
errorratio=0.1;
v0=[10:2:100];
v=v0.*5/18;
x=v.*tau_o;
m=1;n=0;m1=1;
c1=1;c2=1;c3=1;c4=1;c5=1;c6=1;c7=1;c8=1;c9=1;c10=1;

WLANDataRate=11;
dw=5;phai=129.6;d_plus=120;d_minus=140;
Ph=0.2;



%----------------------------------------------------------

for ik = 1 :length(v)
    p1(ik)=0;p0(ik)=0;p3(ik)=0;p4(ik)=0;p5(ik)=0;p6(ik)=0;p7(ik)=0;p8(ik)=0;p9(ik)=0;p10(ik)=0;
    num_break(ik) = 0;
    num_break_Min(ik) = 0;
    esterror_ave(ik) = 0;
    esterror_sum(ik) = 0;
    wlantime(ik) = 0; 
    wuse(ik) = 0; 
    wuse_Min(ik) = 0;
    if v(ik)<= 2
        CellDataRate = 0.384;
    else CellDataRate = 0.144;
    end
    for ij = 1 : 1000 
        theta_i(ik,ij)=2*pi*rand(1);
        theta_o(ik,ij)=2*pi*rand(1);
        theta(ik,ij)=theta_i(ik,ij)-theta_o(ik,ij);
        if theta(ik,ij) < 0
            theta(ik,ij) = abs(theta(ik,ij));
        end    
        %----------------------------------------------------------
        noise_phai(ik,ij) = getnoise(sigma);
        RSS_phai(ik,ij) = 10*log10(Et)-10*beta*log10(phai)+noise_phai(ik,ij);
        phai_est(ik,ij) = 10^((10*log10(Et)-RSS_phai(ik,ij))/10/beta);
        
        %%%%%%%%%%%%%
        L(ik,ij)=sqrt(2*R^2*(1-cos(theta(ik,ij))));
        Lh(ik,ij) = 0.5*L(ik,ij);
        L_OM(ik,ij) = sqrt(R^2-Lh(ik,ij)^2);
        wlantime(ik) = wlantime(ik) + L(ik,ij)/v(ik);     
        %Pb of our method
        if v0(ik)>25
        if (theta(ik,ij)>=acos(1-v(ik)^2*(tau_i+tau_o)^2/2/R^2)) & (theta(ik,ij)<=2*pi-acos(1-v(ik)^2*(tau_i+tau_o)^2/2/R^2))
            if R < v(ik)*tau_o
                num_break(ik) = num_break(ik)+1;
                wuse(ik) = wuse(ik)+L(ik,ij)/v(ik)-tau_i;
                bandwidth(ik) = wuse(ik)*WLANDataRate + (wtime(ik)-wuse(ik))*CellDataRate;
                c1 = c1+1;
            else
                r(ik) = sqrt(v(ik)^2*tau_o^2+R^2-sqrt(2*(1-cos(pi-pi*Ph)))*v(ik)*tau_o*R);
%                 r(ik) = R - v(ik)*tau_o;
%                 [r(ik),p(ik),flag(ik)] = getthreshold(R,v(ik),tau_o);
                r(ik) = r(ik)-R*errorratio;
                L_bound(ik) = v(ik)*tau_o;
                l_OS1(ik,ij) = sqrt((v(ik).*sample_delay).^2+L_OM(ik,ij)^2);
                l_OS2(ik,ij) = sqrt((2*(v(ik)*sample_delay))^2+L_OM(ik,ij)^2);        
                noise_S1(ik,ij) = getnoise(sigma);
                noise_S2(ik,ij) = getnoise(sigma);
                RSS_S1(ik,ij) = 10*log10(Et)-10*beta*log10(l_OS1(ik,ij))+noise_S1(ik,ij);
                RSS_S2(ik,ij) = 10*log10(Et)-10*beta*log10(l_OS2(ik,ij))+noise_S2(ik,ij);
                l_OS1_est(ik,ij) = 10^((10*log10(Et)-RSS_S1(ik,ij))/10/beta);
                l_OS2_est(ik,ij) = 10^((10*log10(Et)-RSS_S2(ik,ij))/10/beta);
                L_OM_est(ik,ij) = sqrt(l_OS1_est(ik,ij)^2 - (v(ik)*sample_delay)^2);%(l_OS2_est(ik,ij)^2-l_OS1_est(ik,ij)^2-v(ik)^2*sample_delay^2)^2/4/v(ik)^2/sample_delay^2
                Lh_est(ik,ij) = sqrt(R^2-L_OM_est(ik,ij)^2);
                %Calculate the distance estimation error

%                     if L_OM(ik,ij) > r(ik)
%                         if (L(ik,ij)-tau_i-v(ik)*sample_delay) < v(ik)*tau_o
%                             num_break(ik) = num_break(ik)+1;
%                             wuse(ik) = wuse(ik)+L(ik,ij)/v(ik)-tau_i;
%                             c4 = c4+1;
%                         else wuse(ik) = wuse(ik)+v(ik)*sample_delay-tau_i+tau_o;
%                             c5 = c5+1;
%                         end
%                     else
%                         L_bound(ik,ij) = sqrt(R^2-L_OM(ik,ij)^2) -
%                         sqrt(r(ik)^2-L_OM(ik,ij)^2);
                            noise_r(ik,ij) = getnoise(sigma);
                            RSS_r(ik,ij) = 10*log10(Et)-10*beta*log10(r(ik))+noise_r(ik,ij);
                            r_est(ik,ij) = 10^((10*log10(Et)-RSS_r(ik,ij))/10/beta);
                        d_R2(ik,ij)=sqrt(0.5*R^2*(1-cos(theta(ik,ij))));
                        if r_est(ik,ij)>=R
                           num_break(ik) = num_break(ik)+1;
                           wuse(ik) = wuse(ik)+L(ik,ij)/v(ik)-tau_i;
                           L_bound_est(ik,ij) = 0;
                           c6 = c6+1;
                        elseif r_est(ik,ij)<L_OM(ik,ij)
                               if (L(ik,ij)-tau_i*v(ik)-v(ik)*sample_delay) < v(ik)*tau_o                    
                               num_break(ik) = num_break(ik)+1;
                               wuse(ik) = wuse(ik)+L(ik,ij)/v(ik)-tau_i;   
                               L_bound_est(ik,ij) = 0;
                               c7 = c7+1;
                               else
%                                    wuse(ik) = wuse(ik)+L(ik,ij)/v(ik)-tau_i;
                                   wuse(ik) =wuse(ik)+sample_delay+tau_o;
                                   c8 = c8+1;
                                   L_bound_est(ik,ij) = L(ik,ij)-v(ik)*tau_i-v(ik)*sample_delay;
                               end 
                               
                        else
                            d_r(ik,ij)=sqrt(r_est(ik,ij)^2-R^2+d_R2(ik,ij)^2);
                            L_bound_est(ik,ij)=(d_R2(ik,ij)-d_r(ik,ij));
                            if L_bound_est(ik,ij) ~= 0  &  L_bound_est(ik,ij) < v(ik)*tau_o
                                num_break(ik) = num_break(ik)+1;
                                wuse(ik) = wuse(ik)+L(ik,ij)/v(ik)-tau_i;
                                c9 = c9+1;
                            elseif L_bound_est(ik,ij) ~= 0
%                                 wuse(ik) = wuse(ik)+L(ik,ij)/v(ik)-tau_i;
                                wuse(ik) =wuse(ik)+L(ik,ij)/v(ik)-tau_i+tau_o-L_bound_est(ik,ij)/v(ik);
                                c10 = c10+1;
                                bandwidth(ik) = wuse(ik)*WLANDataRate + (wlantime(ik)-wuse(ik))*CellDataRate;
                            end
                        end
                        esterror(ik,ij) = abs(L_bound_est(ik,ij)-L_bound(ik))/L_bound(ik);
                        esterror_sum(ik) = esterror_sum(ik)+esterror(ik,ij); 
                        m = m+1; %m is used to count the number of boundary estimation
                
            end
        end
        else
            if (theta(ik,ij)>=(2*acos(r_HY(3)/R))) & (theta(ik,ij)<=(2*pi-2*acos(r_HY(3)/R)))
            noise_r(ik,ij) = getnoise(sigma);
            RSS_r(ik,ij) = 10*log10(Et)-10*beta*log10(r_HY(1))+noise_r(ik,ij);
            r_est(ik,ij) = 10^((10*log10(Et)-RSS_r(ik,ij))/10/beta);
            d_R2(ik,ij)=sqrt(0.5*R^2*(1-cos(theta(ik,ij))));
            if r_est(ik,ij)>=R
                num_break(ik) = num_break(ik)+1;
                wuse(ik) = wuse(ik)+L(ik,ij)/v(ik)-tau_i;
            elseif r_est(ik,ij)<=L_OM(ik,ij)
                   if (L(ik,ij)-tau_i*v(ik)-v(ik)*sample_delay) < v(ik)*tau_o                    
                   num_break(ik) = num_break(ik)+1;
                   wuse(ik) = wuse(ik)+L(ik,ij)/v(ik)-tau_i;
                   else wuse(ik) = wuse(ik)+sample_delay+tau_o;
                   end 
            else
            d_r(ik,ij)=sqrt(r_est(ik,ij)^2-R^2+d_R2(ik,ij)^2);
            L_bound_est(ik,ij)=d_R2(ik,ij)-d_r(ik,ij);
            if L_bound_est(ik,ij) ~= 0  &  L_bound_est(ik,ij) < v(ik)*tau_o
                num_break(ik) = num_break(ik)+1;
                wuse(ik) = wuse(ik)+L(ik,ij)/v(ik)-tau_i;
            elseif L_bound_est(ik,ij) ~= 0
%                 wuse(ik) = wuse(ik)+L(ik,ij)/v(ik)-tau_i;
                wuse(ik) =wuse(ik)+L(ik,ij)/v(ik)-tau_i+tau_o-L_bound_est(ik,ij)/v(ik);
            end
            end
        end    
        end
        
        %Pb of Min's method
        if (theta(ik,ij)>=(2*acos(r_HY(3)/R))) & (theta(ik,ij)<=(2*pi-2*acos(r_HY(3)/R))) 
            noise_rHY(ik,ij) = getnoise(sigma_Min);
            RSS_rHY(ik,ij) = 10*log10(Et)-10*beta*log10(r_HY(1))+noise_rHY(ik,ij);
            rHY_est(ik,ij) = 10^((10*log10(Et)-RSS_rHY(ik,ij))/10/beta);
            Min_err_sum(ik) = 0;
            Min_err(ik,ij) = abs(rHY_est(ik,ij)-r_HY(1))/r_HY(1);
            Min_err_sum(ik) = Min_err_sum(ik)+Min_err(ik,ij);
            m1 = m1+1;
            d_R2_Min(ik,ij)=sqrt(0.5*R^2*(1-cos(theta(ik,ij))));
%             L_bound_Min(ik,ij) = getboundary(R,rHY_est(ik,ij),theta(ik,ij));
            if rHY_est(ik,ij)>=R
                num_break_Min(ik) = num_break_Min(ik)+1;
                wuse_Min(ik) = wuse_Min(ik)+L(ik,ij)/v(ik)-tau_i;
                p1(ik) = p1(ik)+1;
            elseif rHY_est(ik,ij)<=L_OM(ik,ij) & rHY_est(ik,ij) ~=0
                   if (L(ik,ij)-tau_i*v(ik)-v(ik)*sample_delay) < v(ik)*tau_o                    
                   num_break_Min(ik) = num_break_Min(ik)+1;
                   wuse_Min(ik) = wuse_Min(ik)+L(ik,ij)/v(ik)-tau_i;
                   p0(ik) = p0(ik)+1;
                   else wuse_Min(ik) = wuse_Min(ik)+sample_delay+tau_o;
                       p3(ik) = p3(ik)+1;
                   end 
            else
            d_r_Min(ik,ij)=sqrt(rHY_est(ik,ij)^2-R^2+d_R2_Min(ik,ij)^2);
            d2_Min(ik,ij)=d_R2_Min(ik,ij)-d_r_Min(ik,ij);
            if d2_Min(ik,ij) ~= 0  &  d2_Min(ik,ij) < v(ik)*tau_o
                num_break_Min(ik) = num_break_Min(ik)+1;
                wuse_Min(ik) = wuse_Min(ik)+L(ik,ij)/v(ik)-tau_i;
                p4(ik) = p4(ik)+1;
            elseif d2_Min(ik,ij) ~= 0
%                 wuse_Min(ik) = wuse_Min(ik)+L(ik,ij)/v(ik)-tau_i;
                wuse_Min(ik) =wuse_Min(ik)+L(ik,ij)/v(ik)-tau_i+tau_o-d2_Min(ik,ij)/v(ik);
                p5(ik) = p5(ik)+1;
            end
            end
        end
    end
    esterror_ave(ik) = esterror_sum(ik)/m;
    Pb(ik) = num_break(ik);
    Pb_Min(ik) = num_break_Min(ik);
    wuse(ik) = wuse(ik)/wlantime(ik);
    wuse_Min(ik) = wuse_Min(ik)/wlantime(ik);
    Min_err_ave(ik) = Min_err_sum(ik)/m1;
end
    

figure
% subplot(2,1,1)
plot(v0,Pb_Min,'-rx');
hold on
plot(v0,Pb,'-b');
hold on

legend('GHO','HTTE');
grid  ('on')
xlabel('Velocity (km/h)')
ylabel('Connection Breakdown Probability')
% title ('Simulation Results')

% subplot(2,1,2)
figure
plot(v0,wuse_Min,'-rx');
hold on
plot(v0,wuse,'-b');
hold on
legend('GHO','HTTE');
grid  ('on')
xlabel('Velocity (km/h)')
ylabel('WLAN Usage')
% title ('Simulation Results')

% % for i=1:length(x)
% %     num_breakdown(i)=0;
% %     for j=1:length(d2)
% %         if d2(j)<x(i)
% %             num_breakdown(i)=num_breakdown(i)+1;
% %         end
% %     end
% %     pb_simu(i)=num_breakdown(i)/ij;
% % end


% % plot(v0,pb_simu,'-b');
% % hold on

%--------------------------------------------------
for j=1:length(v)
if r_HY(1)<R-v(j)*tau_o
    p2(j)=0;
elseif r_HY(1)>R
    p2(j)=1;
else p2(j)=1-1/pi*(acos(2*r_HY(1).^2/R^2-(R^2-r_HY(1).^2-v(j)^2*tau_o^2).^2/2./v(j).^2/tau_o^2/R^2-1));
end
end
figure
% subplot(2,1,1)
plot(v0,Pb_Min,'-ro');
hold on
plot(v0,Pb,'-bo');
hold on
plot(v0,p2,'-r*');
hold on
HTTE_pb=zeros(1,length(v0));
plot(v0,HTTE_pb,'-b*');
grid  ('on')
xlabel('Velocity (km/h)')
ylabel('Connection Breakdown Probability')
legend('GHO-Simulation','HTTE-Simulation','GHO-Theoretical','HTTE-Theoretical');
% plot(v0,p2(2,:),'-r');
% hold on
% plot(v0,p2(3,:),'--bx');
% hold on
% legend('r_{HY}=120','r_{HY}=130','r_{HY}=140');

% title ('Theoretical Analysis')
