% Copyright (c) 2010 Iris Yan

% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.

% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

function [ x1,y1,x2,y2 ] = generatepoints( side_length,R1,x_AP1,y_AP1,R2,x_AP2,y_AP2 )
%This function generates a random point on the boundary of the square

p=unidrnd(4); %Randomly choose one of the four sides of the square
if p==1
    x1=0;
    y1=unidrnd(side_length+1)-1;
    x2=side_length;
    y2=unidrnd(side_length+1)-1;
elseif p==2
    x1=unidrnd(side_length+1)-1;
    y1=side_length;
    x2=unidrnd(side_length+1)-1;
    y2=0;
elseif p==3
    x1=side_length;
    y1=unidrnd(side_length+1)-1;
    x2=0;
    y2=unidrnd(side_length+1)-1;
else
    x1=unidrnd(side_length+1)-1;
    y1=0;
    x2=unidrnd(side_length+1)-1;
    y2=side_length;
end
    



